theory Safety_Proof_Parsers
imports
  Safety_Proof_Parser
  Linear_Integer_Inequalities
begin

definition "constant_parser = Xmlt.int ''constant''"

definition product_parser :: "'a xmlt \<Rightarrow> 'a le_exp xmlt" where "product_parser v =
  xml_if ''product''
    (Xmlt.pair ''product'' constant_parser v (\<lambda> i x. Fun (Cmult i) [Var (x,IntegerT)]))
    (xml_if ''constant''
      (xml_app constant_parser lia_const)
      (xml_app v (\<lambda>x. Var (x,IntegerT))))"

definition "lin_exp_parser v =
  xml_if ''sum''
    (Xmlt.many ''sum'' (product_parser v) (foldl add (lia_const 0)))
    (product_parser v)"

definition lin_atom_parser :: "'a xmlt \<Rightarrow> 'a le_exp xmlt" where
  "lin_atom_parser v = Xmlt.options [
    (''leq'', xml1to2elements ''leq'' (lin_exp_parser v) (lin_exp_parser v)
      (\<lambda> l r. Fun Lesseq [l, case r of None \<Rightarrow> lia_const 0 | Some r \<Rightarrow> r])),
    (''less'', Xmlt.pair ''less'' (lin_exp_parser v) (lin_exp_parser v) (\<lambda> l r. Fun Less [l,r]))
  ]"

definition hint :: "nat list xmlt" where
  "hint = Xmlt.singleton ''linearImplicationHint''
    (Xmlt.many ''linearCombination'' constant_parser (map nat)) id"

abbreviation "LIA_parse_safety_cert_problem \<equiv>
  parse_safety_cert_problem node trans_id (lin_atom_parser variable) (lin_atom_parser trans_variable) hint"

end