theory Termination_Via_Invariants
  imports Invariant_Checker Cooperation_Program
begin

locale delete_edge_checker =
  art_checker T tc tc2
  for T :: "('f::show,'t::show,'d) theory"
  and tc :: "('h::show,'f,'v::show,'t) theory_checker"
  and tc2
  and rf :: "('l sharp \<Rightarrow> ('f,'v','t) exp)"
  and range_eval :: "'d \<Rightarrow> 'a"
  and S :: "('a \<times> 'a) set" 
  and NS :: "('a \<times> 'a) set"
  and bnd :: "'a"
  and invariant_condition :: "('l sharp \<Rightarrow> ('f,'v','t) formula list)
                              \<Rightarrow> 'tr \<times> ('f, 'v', 't, 'l sharp) transition \<Rightarrow> shows check"
  and strict_condition :: "('l sharp \<Rightarrow> ('f,'v','t) formula list)
                           \<Rightarrow> 'tr \<times> ('f, 'v', 't, 'l sharp) transition \<Rightarrow> shows check"
  and bound_condition :: "('l sharp \<Rightarrow> ('f,'v','t) formula list)
                           \<Rightarrow> 'tr \<times> ('f, 'v', 't, 'l sharp) transition \<Rightarrow> shows check" +
  assumes nio:"non_inf_order S NS"
  and invariant_condition_isOK:
    "\<And>tr \<tau> I s t \<phi>.
       \<forall>l. list_all local.formula (I l) \<Longrightarrow>
       local.formula (transition.formula \<tau>) \<Longrightarrow>
       is_sharp_transition \<tau> \<Longrightarrow>
       isOK (invariant_condition I (tr, \<tau>)) \<Longrightarrow>
       (s, t) \<in> transition_step \<tau> \<Longrightarrow>
       \<phi> \<in> set (I (state.location s)) \<Longrightarrow>
       valuation s \<Turnstile> \<phi> \<Longrightarrow>
       (range_eval (eval (valuation s) (rf (state.location s))), range_eval (eval (valuation t) (rf (state.location t)))) \<in> NS \<union> S"
  and strict_condition_isOK: 
    "\<And>tr \<tau> I s t \<phi>.
       \<forall>l. list_all local.formula (I l) \<Longrightarrow>
       local.formula (transition.formula \<tau>) \<Longrightarrow>
       is_sharp_transition \<tau> \<Longrightarrow>
       isOK (bound_condition I (tr, \<tau>)) \<Longrightarrow>
       isOK (strict_condition I (tr, \<tau>)) \<Longrightarrow>
       (s, t) \<in> transition_step \<tau> \<Longrightarrow>
       \<phi> \<in> set (I (state.location s)) \<Longrightarrow>
       valuation s \<Turnstile> \<phi> \<Longrightarrow>
       (range_eval (eval (valuation s) (rf (state.location s))), range_eval (eval (valuation t) (rf (state.location t)))) \<in> S"
  and bound_condition_isOK: 
    "\<And>tr \<tau> I s t \<phi>.
       \<forall>l. list_all local.formula (I l) \<Longrightarrow>
       local.formula (transition.formula \<tau>) \<Longrightarrow>
       is_sharp_transition \<tau> \<Longrightarrow>
       isOK (bound_condition I (tr, \<tau>)) \<Longrightarrow>
       (s, t) \<in> transition_step \<tau> \<Longrightarrow>
       \<phi> \<in> set (I (state.location s)) \<Longrightarrow>
       valuation s \<Turnstile> \<phi> \<Longrightarrow>
       (range_eval (eval (valuation s) (rf (state.location s))), bnd) \<in> S"
begin

lemma condition_checker:
shows "condition_checker invariant_condition strict_condition bound_condition
  (\<lambda>s. range_eval (eval (valuation s) (rf (state.location s)))) S NS bnd"
  using condition_checkerI[OF nio invariant_condition_isOK strict_condition_isOK bound_condition_isOK].

definition reduction where
"reduction lst = (map (\<lambda> (st,v). no_modification_update (eliminate_edges st invariant_condition strict_condition bound_condition v)) lst)"

lemma all_in_reduction_disj_invariant_update[simp]:
  shows "list_all disj_invariant_update (reduction lst)"
  using condition_checker by(auto simp:pred_list_def reduction_def)

end
end